<?php
  //-------------------------------------------------------------------------
  //                             ViPER Guestbook
  //                               install.php
  //
  //                              Version: X1.0
  //-------------------------------------------------------------------------
  //                   Copyright (c) 2004-2005  Marc Stein
  //                        http://www.vipergb.de.vu
  //-------------------------------------------------------------------------
  //  This program is free software. You can redistribute it and/or modify
  //  it under the terms of the License that was distributed with this file!
  //-------------------------------------------------------------------------
define('IN_COPPERMINE', true);

require('include/init.inc.php');
if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

$GB_DIR = "guestbook";
$GB_FILE = "guestbook.php";

  define ( "MAXLEN_NAME"     , "40" );
  define ( "MAXLEN_EMAIL"    , "40" );
  define ( "MAXLEN_HOMEPAGE" , "40" );
  define ( "MAXLEN_AIM"      , "40" );
  define ( "MAXLEN_MSN"      , "40" );
  define ( "MAXLEN_YAHOO"    , "40" );
  define ( "MAXLEN_SKYPE"    , "40" );
  define ( "MAXLEN_JABBER"   , "40" );

  global $ENCODING;
  
  if (!function_exists('mysqli_connect') && !function_exists('mysql_connect')) 
    die("<center><b>Fatal error</b>: The MySQL(i) extension cannot be loaded - please check your PHP configuration !");

  if (!file_exists("$GB_DIR/lang/langinstall.inc"))
    die("<center>Missing file: <b>$GB_DIR/lang/langinstall.inc</b> !");
  @include("$GB_DIR/lang/langinstall.inc");
  if (file_exists("$GB_DIR/lang/langspecial.inc"))
    include("$GB_DIR/lang/langspecial.inc");
  
 /*coppermine integration */
 $DFLT = array('gb_d' => '', // The config file dir
    'gb_f' => $GB_FILE, // The config file name
    );
 
 function build_gb_file()
{
    global $DFLT, $GB_DIR, $GB_FILE;

    return <<<EOT
<?php 
define('IN_COPPERMINE', true);
require('include/init.inc.php');

pageheader('Guestbook');
define("SCRIPTPATH","$GB_DIR/");
define("MAINSCRIPT","$GB_FILE");
define("PFIX","vgb");
include("$GB_DIR/index.php");
pagefooter(); 
?>
EOT;
}

function write_gb_file()
{
    global $errors, $DFLT;

    $config = build_gb_file();
    @unlink($DFLT['gb_f']);
    if ($fd = @fopen($DFLT['gb_f'], 'wb')) {
        fwrite($fd, $config);
        fclose($fd);
    } else {
        $errors .= "<hr /><br />Unable to write config file '{$DFLT['gb_f']}'<br /><br />";
    }
}

  if (!isset($vgb_fontsizes))
    $vgb_fontsizes = array(10,12,14,18);
    
  define ( "VGB_SMALLSIZE"  , $vgb_fontsizes[0] );
  define ( "VGB_NORMALSIZE" , $vgb_fontsizes[1] );
  define ( "VGB_BIGSIZE"    , $vgb_fontsizes[2] );
  define ( "VGB_HUGESIZE"   , $vgb_fontsizes[3] );

  include("$GB_DIR/functions.php");

  // is the install-lock active ?
  if (file_exists("ht_lock.".EXT))
    Error($lang['alreadyInstalled']);

  vgb_getParameters();

  if (isset($arg['ENCODING'])) 
    $ENCODING = strtolower($arg['ENCODING']);
  else { 
    if (isset($lang['encoding']))
      $ENCODING = $lang['encoding'];
    else
      $ENCODING = "";
  }
  if ($ENCODING != "")
    header("Content-Type: text/html; charset=".$ENCODING);

  $x = ($ENCODING == "utf-8") ? "_utf8" : "";
  include("$GB_DIR/libs/string".$x.".php"); 
  
  echo '
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>ViPER Guestbook - Installation</title>
';
  @include("$GB_DIR/admincss.php");
  echo '
  </head>

  <body><br />';
  //*********************************************************************
  //                          main-routine
  //*********************************************************************

  // include the language-package
    

  // if no parameters are given show the guestbook-entries
  if (!empty($arg)) {
    // are all needed parameters set ?
    setParameters(array("HOSTNAME","USERNAME","PASSWORD","DATABASE",
                        "EMAIL","ADMINPASS","ADMINPASS2","PREFIX"));

    // preset the inputfields
    $preHOSTNAME   = trim($arg['HOSTNAME']);
    $preUSERNAME   = trim($arg['USERNAME']);
    $prePASSWORD   = trim($arg['PASSWORD']);
    $preDATABASE   = trim($arg['DATABASE']);
    $preEMAIL      = trim($arg['EMAIL']);
    $preADMINPASS  = trim($arg['ADMINPASS']);
    $preADMINPASS2 = trim($arg['ADMINPASS2']);
    $preENCODING   = trim($arg['ENCODING']);
    $prePREFIX    = trim($arg['PREFIX']);
    $preEUROPE = (isset($arg['EUROPE'])) ? 1 : 0;
    $preNORTH = (isset($arg['NORTH'])) ? 1 : 0;
    $preSOUTH = (isset($arg['SOUTH'])) ? 1 : 0;
    $preASIA = (isset($arg['ASIA'])) ? 1 : 0;
    $preAFRICA = (isset($arg['AFRICA'])) ? 1 : 0;
    $preOCEANIA = (isset($arg['OCEANIA'])) ? 1 : 0;
    $preDEPENDENCY = (isset($arg['DEPENDENCY'])) ? 1 : 0;
    
    // check the parameters
    if ($preHOSTNAME == "")
      $errorMSG = $lang['noHostname'];
    elseif ($preUSERNAME == "")
      $errorMSG = $lang['noUsername'];
    elseif ($preDATABASE == "")
      $errorMSG = $lang['noDatabase'];
    elseif ($prePREFIX == "")
      $errorMSG = $lang['noPrefix'];
    elseif ($preADMINPASS == "")
      $errorMSG = $lang['noPassword'];
    elseif (($x = vgb_noASCII(array($lang['adminPass'] => $preADMINPASS, $lang['email'] => $preEMAIL, $lang['prefix'] => $prePREFIX))) != "")
      $errorMSG = $lang['noASCII'].$x; 
    elseif (strpos('.',$prePREFIX) !== false)
      $errorMSG = $lang['noASCII'].$lang['prefix'];
    elseif (strtoupper($preADMINPASS) != strtoupper($preADMINPASS2))
      $errorMSG = $lang['wrongPassword'];
    else {
      $est = false;
      if (function_exists('mysqli_connect')) {
        $mySQL = @mysqli_connect($preHOSTNAME,$preUSERNAME,$prePASSWORD,$preDATABASE);
        if ($mySQL) {
          $est = true;
          include("$GB_DIR/libs/db_mysqli.php");
        }
      }  
      if (!$est) {
        if (!function_exists('mysql_connect')) 
          $errorMSG = $lang['noDB'];
        else {
          $mySQL = @mysql_connect($preHOSTNAME,$preUSERNAME,$prePASSWORD)
            or $errorMSG = $lang['noDB'];
      
          if (!isset($errorMSG) && (!@mysql_select_db($preDATABASE)))
            $errorMSG = $lang['noDBAccess'];
          if (!isset($errorMSG))
            include("$GB_DIR/libs/db_mysql.php");
        }
      }
    }
      
    $Prefix = $prePREFIX;

    if (!isset($errorMSG)) {
      // inputs are okay => start installation
      installDB();
      // create ht_lock
      $filetext = "<?php global \$mySQL_Host,\$mySQL_User,\$mySQL_Password,\$mySQL_Database,\$Prefix; \$mySQL_Host = '".
                   AddSlashes($preHOSTNAME)."';".
                   "\$mySQL_User = '".
                   AddSlashes($preUSERNAME)."';".
                   "\$mySQL_Password = '".
                   AddSlashes($prePASSWORD)."';".
                   "\$mySQL_Database = '".
                   AddSlashes($preDATABASE)."';".
                   "\$Prefix = '".
                   AddSlashes($prePREFIX)."'?>";
      $file = @fopen("$GB_DIR/ht_lock.".EXT,"a+")
        or Error($lang['noFile'].htmlspecialchars($filetext,ENT_QUOTES).
                 $lang['noFile2']);
      fputs($file,$filetext);
      fclose($file);
      $screen = 1;
    }
    else
      $screen = 0;
  }
  else {
    $preHOSTNAME = $CONFIG['dbserver'];
    $preUSERNAME = $CONFIG['dbuser'];
    $prePASSWORD = $CONFIG['dbpass'];
    $preDATABASE = $CONFIG['dbname'];
    $prePREFIX = "VGB";
    $preEMAIL = $CONFIG['gallery_admin_email'];
    $preADMINPASS = "";
    $preADMINPASS2 = "";
    $screen = 0;
    $preEUROPE = 1;
    $preNORTH = 1;
    $preSOUTH = 1;
    $preASIA = 1;
    $preAFRICA = 1;
    $preOCEANIA = 1;
    $preDEPENDENCY = 0;
    $preENCODING = (isset($lang['encoding'])) ? $lang['encoding'] : "";
  }

  switch ($screen) {
    case 0: // print the install-mask
            echo "<form action='".$_SERVER['PHP_SELF']."' method='post'>".
                 "<table width=550 align=center><tr>".
                 "<td class='bgright' align=left>".
                 "<center>".
                 "<span class='title'>ViPER Guestbook - ".$lang['install'].
                 "</span>".
                 "<p>".
                 "<span class='option'>".$lang['welcome']."</span><p>";
            printMSG();
            echo "<span class='info'>".$lang['required']."</span><p></center>";
            echo "<ul type=square class='menu'><li>".$lang['mysqlSetup'].
                 "</li></ul>";
            InputField("HOSTNAME",$preHOSTNAME,25,127,
              $lang['hostname'],$lang['hostnameInfo']);
            InputField("USERNAME",$preUSERNAME,25,127,
              $lang['username'],$lang['usernameInfo']);
            InputField("PASSWORD",$prePASSWORD,25,127,
              $lang['password'],$lang['passwordInfo']);
            InputField("DATABASE",$preDATABASE,25,127,
              $lang['database'],$lang['databaseInfo']);
            InputField("PREFIX",$prePREFIX,25,127,
              $lang['prefix'],$lang['prefixInfo']);
            echo "<p><ul type=square class='menu'><li>".$lang['adminSetup'].
                 "</li></ul>";
            InputField("EMAIL",$preEMAIL,25,127,
              $lang['email'],$lang['emailInfo']);
            Password("ADMINPASS",$preADMINPASS,$lang['adminPass'],
              $lang['adminPassInfo']);
            Password("ADMINPASS2",$preADMINPASS2,$lang['adminPass2'],
              $lang['adminPass2Info']);
            echo "<p><ul type=square class='menu'><li>".$lang['countrySetup'].
                 "</li></ul>";
            Checkbox("EUROPE",$preEUROPE,$lang['europe']);
            Checkbox("NORTH",$preNORTH,$lang['north']);
            Checkbox("SOUTH",$preSOUTH,$lang['south']);
            Checkbox("ASIA",$preASIA,$lang['asia']);
            Checkbox("AFRICA",$preAFRICA,$lang['africa']);
            Checkbox("OCEANIA",$preOCEANIA,$lang['oceania']);
            Checkbox("DEPENDENCY",$preDEPENDENCY,$lang['dependency']);
            echo "<ul type=square class='menu'><li>".$lang['selectEncoding'].
                 "</li></ul>";
            Radio("ENCODING",$preENCODING,"iso-8859-1","iso-8859-1 (West European)",$lang['iso-8859-1']);
            Radio("ENCODING",$preENCODING,"iso-8859-2","iso-8859-2 (East European)",$lang['iso-8859-2']);
            Radio("ENCODING",$preENCODING,"iso-8859-3","iso-8859-3 (South European)",$lang['iso-8859-3']);
            Radio("ENCODING",$preENCODING,"iso-8859-4","iso-8859-4 (North European)",$lang['iso-8859-4']);
            Radio("ENCODING",$preENCODING,"iso-8859-5","iso-8859-5 (Cyrillic) ",$lang['iso-8859-5']);
            Radio("ENCODING",$preENCODING,"iso-8859-6","iso-8859-6 (Arabic)",$lang['iso-8859-6']);
            Radio("ENCODING",$preENCODING,"iso-8859-7","iso-8859-7 (Greek)",$lang['iso-8859-7']);
            Radio("ENCODING",$preENCODING,"iso-8859-8","iso-8859-8 (Hebrew)",$lang['iso-8859-8']);
            Radio("ENCODING",$preENCODING,"iso-8859-9","iso-8859-9 (Turkish)",$lang['iso-8859-9']);
            Radio("ENCODING",$preENCODING,"iso-8859-10","iso-8859-10 (Nordic)",$lang['iso-8859-10']);
            Radio("ENCODING",$preENCODING,"iso-8859-11","iso-8859-11 (Thai)",$lang['iso-8859-11']);
            Radio("ENCODING",$preENCODING,"iso-8859-12","iso-8859-12 (Baltic Rim)",$lang['iso-8859-12']);
            Radio("ENCODING",$preENCODING,"iso-8859-14","iso-8859-14 (Celtic)",$lang['iso-8859-14']);
            Radio("ENCODING",$preENCODING,"iso-8859-15","iso-8859-15 (West European)",$lang['iso-8859-1']);
            Radio("ENCODING",$preENCODING,"iso-8859-16","iso-8859-16 (South-Eastern European)",$lang['iso-8859-16']);
            Radio("ENCODING",$preENCODING,"koi8-r","koi8-r (Russian Cyrillic)",$lang['koi8-r']);
            Radio("ENCODING",$preENCODING,"koi8-u","koi8-u (Ukrainian Cyrillic)",$lang['koi8-u']);
            Radio("ENCODING",$preENCODING,"utf-8","utf-8 (Unicode)",$lang['utf-8']);
            Radio("ENCODING",$preENCODING,"",$lang['ownEncoding']);
            echo "<center><p><input type=submit class='button' ".
                 "value='".$lang['startInstall'].
                 "' name='install'><br>&nbsp;</center>".
                 "</td></tr></table>".
                 "</form><br />";
            break;
    case 1: // print the installation-success screen
            echo "<table width=100% height=100%><tr>".
                 "<td align=center valign=middle>".
                 "<table width=400><tr><td class='bgright' align=center>".
                 "<span class='title'>ViPER Guestbook<span><p>".
                 "<span class='info'>".$lang['success']."</span><p>".
                 "<span class='info'>An integrated Viper Guestbook has been installed into your Coppermine Gallery</span><p>".
                 "<a href='$GB_DIR/admin.".EXT."'>&raquo; ".$lang['click'].
                 "</a><br>&nbsp;".
                 "</td></tr></table></td></tr></table>";
  }
  //*********************************************************************
  //                          sub-routines
  //*********************************************************************

  function vgb_servername() {
    $s = "";
    if (isset($_SERVER['SERVER_NAME'])) 
      $s = $_SERVER['SERVER_NAME'];
    elseif (isset($GLOBALS['HTTP_SERVER_VARS']['SERVER_NAME']))
      $s = $GLOBALS['HTTP_SERVER_VARS']['HTTP_HOST'];
    else
      $s = getenv("SERVER_NAME");
    if ($s == "")
      $s = "myserver.com";
    return $s;
  }

  function setParameters ( $inParameters ) {
    // returns if all of the given parameters are set or exit with an error
    global $arg,$lang;

    foreach ($inParameters as $_parameter) {
      if (!isset($arg[$_parameter]))
        error($lang['missingParameter'].$_parameter);
    }
  }

  function printMSG() {
    // prints an error- or statusmessage if defined
    global $lang,$errorMSG,$statusMSG;

    if (isset($errorMSG))
      echo "<center><span class='show'>".$lang['errorOccured'].
           "</span><br><span class='error'>".$errorMSG.
           "</b></span><p></center>";
    elseif (isset($statusMSG))
      echo "<center><br><span class='status'><b>".$statusMSG.
           "</b></span><p></center>";
  }

  function password ( $inName, $inValue, $inText, $inInfo = null ) {
    // prints a password-input-field
    echo "<table width=450 align=center cellpadding=2>".
         "<tr><td align=left class='bgoption'>".
         "<table width=100% cellspacing=0>".
         "<tr><td>".
         "<span class='option'>".
         " &nbsp; $inText </span>".
         "</td><td align=right>".
         "<input class='input' name='$inName' value='".vgb_formdata($inValue)."' maxlength=127".
         " size=25 type=password> &nbsp; ".
         "</td></tr></table></td></tr>";
    if (!is_null($inInfo))
      echo "<tr><td colspan=2 class='bginfo'><blockquote><span class='info'>".
      vgb_removeHTML($inInfo)."</span>".
           "</blockquote></td></tr>";
    echo "</table>";
  }

  function inputfield ( $inName, $inValue, $inLen, $inMaxlen,
                        $inText, $inInfo = null ) {
    // prints an inputfield for text
    echo "<table width=450 align=center cellpadding=2>".
         "<tr><td class='bgoption'>".
         "<table cellspacing=0 width=100%>".
         "<tr><td align=left><span class='option'> &nbsp; $inText </span>".
         "</td><td align=right>".
         "<input class='input' name='$inName' value='".
         vgb_formdata($inValue)."' maxlength=$inMaxlen".
         " size=$inLen type=text> &nbsp; ".
         "</td></tr></table></td></tr>";
    if (!is_null($inInfo))
      echo "<tr><td colspan=2 class='bginfo'><blockquote><span class='info'>".
           vgb_removeHTML($inInfo)."</span>".
           "</blockquote></td></tr>";
    echo "</table>";
  }

  function Checkbox ( $inName, $inValue, $inText, $inInfo = null ) {
    // prints a checkbox
    echo "<table width=450 align=center>".
         "<tr><td align=left class='bgoption'><span class='option'>".
         "<input name='$inName' value='1'";
    if ($inValue)
      echo " checked";
    echo " type=checkbox>".
         " $inText</span></td></tr>";
    if (!is_null($inInfo))
      echo "<tr><td class='bginfo'><blockquote><span class='info'>$inInfo".
           "</span></blockquote></td></tr>";
    echo "</table>";
  }

  function Radio ( $inName, $inPre, $inValue, $inText, $inInfo = null ) {
    // prints a checkbox
    echo "<table width=450 align=center>".
         "<tr><td align=left class='bgoption'><span class='option'>";
    
    echo "<input name='$inName' value='$inValue'";
    if ($inPre == $inValue)
      echo " checked";
    echo " type='radio' /> $inText".
         " </span></td></tr>";
    if (!is_null($inInfo))
      echo "<tr><td class='bginfo'><blockquote><span class='info'>$inInfo".
           "</span></blockquote></td></tr>";
    echo "</table>";
  }

  function addC ( $inName, $inIcon = null ) {
    // adds a country to database

    if (is_Null($inIcon))
      $inIcon = $inName;
    $inIcon = strtolower($inIcon).".gif";
    $inName = strtoupper($inName);
    vgb_query("insert into VGB_COUNTRY values(NULL,'$inName','$inIcon',1)");
  }

  function installDB() {
  global $GB_DIR, $INDEXURL, $CONFIG, $GB_FILE, $BACKURL;
  
  // creates the database for the guestbook
    global $lang,$preEMAIL,$preADMINPASS,$preENCODING,
           $preEUROPE,$preNORTH,$preSOUTH,$preASIA,
           $preAFRICA,$preOCEANIA,$preDEPENDENCY,$prePASSWORD;

    // set the first available skin as default skin
    $_skins = array();
    $_dir = @opendir("$GB_DIR/skins/")
      or error($lang['noSkinDir']);
    while ($_name = readdir($_dir)) {
      if (($_name != ".") && ($_name != ".."))
        $_skins[] = $_name;
    }
    closedir($_dir);
    // if the skindir is empty set an empty string
    $_skin = (sizeof($_skins) == 0) ? "" : $_skins[0];

    $queries = array(
      // build up structure
      "drop table if exists VGB_ACTION",
      "drop table if exists VGB_ADMIN",
      "drop table if exists VGB_COMMENT",
      "drop table if exists VGB_COMMENTSPAM",
      "drop table if exists VGB_COUNTRY",
      "drop table if exists VGB_CUSTOMENTRY",
      "drop table if exists VGB_CUSTOMFIELD",
      "drop table if exists VGB_CUSTOMUSER",
      "drop table if exists VGB_EMAIL",
      "drop table if exists VGB_EMOTICON",
      "drop table if exists VGB_ENTRY",
      "drop table if exists VGB_LANGUAGE",
      "drop table if exists VGB_LOGIN",
      "drop table if exists VGB_MAILSPAM",
      "drop table if exists VGB_RATING",
      "drop table if exists VGB_RATINGBOX",
      "drop table if exists VGB_SESSION",
      "drop table if exists VGB_SETTINGS",
      "drop table if exists VGB_SPAM",
      "drop table if exists VGB_TICKET",
      "drop table if exists VGB_USER",
      "drop table if exists VGB_VISITOR",
      
      "create table if not exists VGB_SETTINGS (
         VERSION           varchar(127) not null,
         ONLINEDATE        date not null,
         ADMINPASSWORD     varchar(127) not null,
         ADMINEMAIL        varchar(127),
         LASTSENDMAIL      date not null,
         ACTIVESKIN        varchar(255) not null,
         SENDNOTICE        bool not null,
         USEFRAMES         bool not null,
         USEUSDATE         bool not null,
         USEEMOTICONS      bool not null,
         PASTENTRIES       int not null,
         MAXSPAMTIME       int not null,
         MAXENTRIES        int not null,
         MAXENTRIESPERPAGE int not null,
         MAXLENENTRY       int not null,
         MAXLENNAME        tinyint unsigned not null,
         MAXLENEMAIL       tinyint unsigned not null,
         MAXLENHOMEPAGE    tinyint unsigned not null,
         MAXLENAIM         tinyint unsigned not null,
         MAXLENMSN         tinyint unsigned not null,
         MAXLENYAHOO       tinyint unsigned not null,
         FORCEBREAK        tinyint unsigned not null,
         ACTIVATELINKS     bool not null,
         ASKEMAIL          bool not null,
         ASKHOMEPAGE       bool not null,
         ASKICQ            bool not null,
         ASKAIM            bool not null,
         ASKMSN            bool not null,
         ASKYAHOO          bool not null,
         ASKCOUNTRY        bool not null,
         FORCECOUNTRY      bool not null,
         HIDEIP            tinyint unsigned not null,
         HIDEHOST          tinyint unsigned not null,
         HIDESTATS         bool not null,
         LIMITBROWSER      int not null,
         LIMITOS           int not null,
         LIMITCOUNTRY      int not null,
         USEFILTER         int not null,
         BADWORDSTRING     varchar(".(vgb_maxlen()*vgb_lenfactor()).") not null,
         ASKPICTURE        bool not null,
         MINX              int not null,
         MAXX              int not null,
         MINY              int not null,
         MAXY              int not null,
         VISITORS          int not null,
         VISITORSSINCE     date not null,
         INDEXURL          varchar(127),
         VGBID1            varchar(255),
         VGBID2            varchar(255),
         FORCEEMAIL        bool not null,
         USEBBCODE         bool not null,
         STRIPCODE         bool not null,
         SIZEMIN           tinyint unsigned not null,
         SIZEMAX           tinyint unsigned not null,
         USERCOLORS        text not null,
         USERFONTS         text not null,
         ASKPICTEXT        bool not null,
         FILTERNAME        bool not null,
         FILTEREMAIL       bool not null,
         FILTERHOMEPAGE    bool not null,
         FILTERAIM         bool not null,
         FILTERMSN         bool not null,
         FILTERYAHOO       bool not null,
         FILTERPICTEXT     bool not null,
         ASKPRIVATE        bool not null,
         PRIVPARAMETER     varchar(30),
         ASKHIDEEMAIL      bool not null,
         USEMAILER         tinyint unsigned not null,
         USEADMINEMO       bool not null,
         USEIFRAME         bool not null,
         PRECOUNTRY        int,
         ALLOWCOMMENTS     bool not null,
         ADDHOURS          int not null,
         ADDMINUTES        int not null,
         ADDSECONDS        int not null,
         COMMENTNAME       varchar(".(MAXLEN_NAME*vgb_lenfactor()).") not null,
         COMMENTEMAIL      varchar(".MAXLEN_EMAIL.") not null,
         MODERATEDMODE     bool not null,
         DEACTIVATED       bool not null,
         BACKURL           varchar(127),
         ALLOWSEARCH       bool not null,
         USEQUOTE          bool not null,
         BANLIST           text not null,
         BANROBOTS         bool not null,
         MAXEMPTYLINES     int not null,
         EMAILTOOLTIP      varchar(".(vgb_maxlen()*vgb_lenfactor()).") not null,
         EMAILFROM         varchar(127) not null,
         FIRSTENTRY        bool not null,
         FIRSTCOMMENT      bool not null,
         ENTRYSENT         bool not null,
         COMMENTSENT       bool not null,
         PASSPREFIX        varchar(20) not null,
         THUMBNAILX        int not null,
         THUMBNAILY        int not null,
         ENCODING          varchar(30) not null,
         HOSTRESOLVING     bool not null,
         AMPMTIME          bool not null,
         REDIRECTSHOW      bool not null,
         EMAILMETHOD       bool not null,
         RETURNPATH        varchar(127) not null,
         MAILCHARSET       varchar(30) not null,
         CMDLINEPARAM      varchar(60) not null,
         CRLFHEADER        bool not null,
         SMTPHOST          varchar(127) not null,
         SMTPPORT          int unsigned not null,
         SMTPUSERNAME      varchar(60) not null,
         SMTPPASSWORD      varchar(60) not null,
         INSERTSKINNAME    bool not null,
         ASKSKYPE          bool not null,
         ASKJABBER         bool not null,
         ASKGADUGADU       bool not null,
         MAXLENSKYPE       tinyint unsigned not null,
         MAXLENJABBER      tinyint unsigned not null,
         FILTERSKYPE       bool not null,
         FILTERJABBER      bool not null,
         ASKGENDER         bool not null,
         FORCEGENDER       bool not null,
         MAXFILESIZE       int unsigned not null,
         DEFAULTNAME       varchar(255) not null,
         ADMINLINK         bool not null,
         USECOOKIES        bool not null,
         USETICKETS        bool not null,
         BBCODEMASK        int unsigned not null,
         QUOTESTYLE        varchar(127) not null,
         CODESTYLE         varchar(127) not null,
         USETOOLBAR        tinyint not null,
         SAVEACTIONS       int not null,
         MAILLIMIT         int not null,
         CHECKMAILS        bool not null,
         VERSIONCHECK      bool not null,
         FIRSTEMAIL        bool not null,
         EMAILSENT         bool not null
        )",
      "create table if not exists VGB_ENTRY (
         ID                int primary key auto_increment,
         DATE              date not null,
         NAME              varchar(".(MAXLEN_NAME*vgb_lenfactor())."),
         ENTRY             text not null,
         COMMENT           text,
         COUNTRY           int,
         EMAIL             varchar(".MAXLEN_EMAIL."),
         HOMEPAGE          varchar(".MAXLEN_HOMEPAGE."),
         ICQ               int unsigned,
         AIM               varchar(".MAXLEN_AIM."),
         MSN               varchar(".MAXLEN_MSN."),
         YAHOO             varchar(".MAXLEN_YAHOO."),
         IP                varchar(16) not null,
         BROWSER           varchar(255) not null,
         HOSTNAME          varchar(128) not null,
         SIGNTIME          time,
         PICTURE           varchar(32),
         PICTEXT           varchar(".(vgb_maxlen()*vgb_lenfactor())."),
         PRIVATE           varchar(20),
         HIDEEMAIL         bool not null,
         UNMODERATED       bool not null,
         SKYPE             varchar(".MAXLEN_SKYPE."),
         JABBER            varchar(".MAXLEN_JABBER."),
         GADUGADU          int unsigned,
         GENDER            tinyint unsigned not null,
         CLOSED            bool not null,
         STICKY            tinyint unsigned not null
       )",
      "create table if not exists VGB_CUSTOMFIELD (
         ID                tinyint unsigned primary key auto_increment,
         NAME              varchar(255) not null,
         TYPE              tinyint not null,
         RULES             text not null,
         PRIORITY          tinyint unsigned not null,
         FRCE              bool not null,
         STATS             bool not null,
         LIMITSTATS        int not null,
         FORMTEXT          varchar(255) not null,
         FILTER            bool not null,
         PREALLOCATE       varchar(255),
         USEWORDWRAP       bool not null
       )",
      "create table if not exists VGB_CUSTOMENTRY (
         ENTRY_ID          int not null,
         FIELD_ID          tinyint unsigned not null,
         CONTENT           varchar(255),
         primary key(ENTRY_ID,FIELD_ID)
       )",
      "create table if not exists VGB_RATINGBOX (
         ID                tinyint unsigned primary key auto_increment,
         NAME              varchar(255) not null,
         PRIORITY          tinyint unsigned not null,
         FRCE              bool not null,
         STATS             bool not null,
         FORMTEXT          varchar(255) not null,
         MAXVALUE          int not null default 5
       )",
      "create table if not exists VGB_RATING (
         ENTRY_ID          int not null,
         BOX_ID            tinyint unsigned not null,
         RATING            tinyint not null,
         primary key(ENTRY_ID,BOX_ID)
       )",
      "create table if not exists VGB_SPAM (
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         TRIES             tinyint,
         primary key(IP,TSTAMP)
       )",
      "create table if not exists VGB_VISITOR (
         ID                int primary key auto_increment,
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         HOSTNAME          varchar(128) not null,
         BROWSER           varchar(255) not null,
         ACTIVE            bool not null,
         ACTIONS           int not null
       )",
      "create table if not exists VGB_ACTION (
         VID               int not null,
         TSTAMP         datetime not null,
         ACTION            int not null,
         DETAILS           varchar(255)
      )",
      "create table if not exists VGB_EMOTICON (
         ID                int primary key auto_increment,
         CODE              varchar(32) not null,
         FILENAME          varchar(127) not null,
         PRIORITY          tinyint unsigned not null
      )",
      "create table if not exists VGB_COUNTRY (
         ID                int primary key auto_increment,
         NAME              varchar(255) not null,
         FLAGICON          varchar(127) not null,
         TRANSLATE         bool not null
      )",
      "create table if not exists VGB_SESSION (
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         SESSIONID         varchar(20) not null,
         TRY               tinyint ,
         ADMIN             int,
         VERSIONS          varchar(127) not null,
         primary key(IP,TSTAMP)
      )",
      "create table if not exists VGB_MAILSPAM (
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         EMAIL             varchar(127) not null,
         primary key(IP,TSTAMP,EMAIL)
      )",
      "create table if not exists VGB_LOGIN (
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         ENTRYID           int not null,
         TRY               tinyint ,
         SESSIONID         varchar(20),
         primary key(IP,TSTAMP,ENTRYID)
      )",
      "create table if not exists VGB_COMMENT (
         ID                int primary key auto_increment,
         ENTRYID           int not null,
         NAME              varchar(".(MAXLEN_NAME*vgb_lenfactor()).") not null,
         EMAIL             varchar(".MAXLEN_EMAIL."),
         TEXT              text not null,
         IP                varchar(16) not null,
         HOSTNAME          varchar(128) not null,
         DATE              date not null,
         SIGNTIME          time not null,
         ADMIN             bool not null,
         UNMODERATED       bool not null
      )",
      "create table if not exists VGB_COMMENTSPAM (
         IP                varchar(16) not null,
         TSTAMP         datetime not null,
         ENTRYID           int not null,
         primary key(IP,TSTAMP,ENTRYID)
      )",
      "create table if not exists VGB_EMAIL (
         ID                int primary key auto_increment,
         ACTIVE            bool not null,
         SUBJECT           varchar(127),
         MESSAGE           text,
         HTML              bool not null,
         UNCHECKED         bool not null,
         IP                varchar(16) not null,
         HOSTNAME          varchar(128) not null,
         TSTAMP         datetime not null,
         SENDTO            varchar(127) not null,
         REPLYTO           varchar(127) not null
      )",
      "create table if not exists VGB_USER (
         ID                int primary key auto_increment,
         NAME              varchar(".(MAXLEN_NAME*vgb_lenfactor()).") not null,
         RESERVED          bool not null,
         PASSWORD          varchar(30) not null,
         SIGNATURE         text not null,
         EMAIL             varchar(".MAXLEN_EMAIL.") not null,
         HIDEEMAIL         bool not null,
         HOMEPAGE          varchar(".MAXLEN_HOMEPAGE.") not null,
         ICQ               int unsigned not null,
         AIM               varchar(".MAXLEN_AIM.") not null,
         MSN               varchar(".MAXLEN_MSN.") not null,
         YAHOO             varchar(".MAXLEN_YAHOO.") not null,
         COUNTRY           int not null,
         PICTEXT           varchar(".(vgb_lenfactor()*vgb_maxlen()).") not null,
         PICTURE           varchar(32) not null,
         SKYPE             varchar(".MAXLEN_SKYPE.") not null,
         JABBER            varchar(".MAXLEN_JABBER.") not null,
         GADUGADU          int unsigned not null,
         GENDER            tinyint unsigned not null
      )",
      "create table if not exists VGB_CUSTOMUSER (
         USER_ID           int not null,
         FIELD_ID          tinyint unsigned not null,
         CONTENT           varchar(255) not null,
         primary key(USER_ID,FIELD_ID)
      )",
      "create table if not exists VGB_LANGUAGE (
         ID                int primary key auto_increment,
         NAME              varchar(255) not null,
         LANGDIR           varchar(127) not null,
         SKINDIR           varchar(127) not null,
         PRIORITY          tinyint unsigned not null
       )",
      "create table if not exists VGB_TICKET (
         ID                int primary key auto_increment, 
         IP                varchar(16) not null, 
         TSTAMP         datetime not null, 
         TICKET varchar(5) not null
      )",
      "create table if not exists VGB_ADMIN (
         ID                int primary key auto_increment,
         NAME              varchar(255) not null,
         PASSWORD          varchar(30) not null,
         LASTLOGIN         datetime not null,
         LOGINS            int unsigned not null,
         COMMENTNAME       varchar(255) not null,
         COMMENTEMAIL      varchar(127) not null,
         ACCEPT            bool not null,
         REJECT            bool not null,
         EDIT              bool not null,
         COMMENT           bool not null,
         DEL               bool not null,
         CLOSE             bool not null,
         BANUSER           bool not null
      )",
      // clear all existing datas
      "delete from VGB_SETTINGS",
      "delete from VGB_ENTRY",
      "delete from VGB_CUSTOMFIELD",
      "delete from VGB_CUSTOMENTRY",
      "delete from VGB_RATINGBOX",
      "delete from VGB_RATING",
      "delete from VGB_COUNTRY",
      "delete from VGB_EMOTICON",
      "delete from VGB_SPAM",
      "delete from VGB_VISITOR",
      "delete from VGB_ACTION",
      "delete from VGB_SESSION",
      "delete from VGB_MAILSPAM",
      "delete from VGB_LOGIN",
      "delete from VGB_COMMENT",
      "delete from VGB_COMMENTSPAM",
      "delete from VGB_EMAIL",
      "delete from VGB_USER",
      "delete from VGB_CUSTOMUSER",
      "delete from VGB_LANGUAGE",
      "delete from VGB_TICKET",
      "delete from VGB_ADMIN",
      // initialize default mails
      "insert into VGB_EMAIL values(1,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values(2,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values(3,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values(4,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values(5,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (6,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (7,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (8,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (9,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (10,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (11,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (12,0,null,null,0,0,'','',now(),'','')",
      "insert into VGB_EMAIL values (20,0,null,null,0,0,'','',now(),'','')",

      // create default emoticons
      "insert into VGB_EMOTICON values(null,':-)','smile.gif',20)",
      "insert into VGB_EMOTICON values(null,':-D','laugh.gif',25)",
      "insert into VGB_EMOTICON values(null,';-)','wink.gif',30)",
      "insert into VGB_EMOTICON values(null,':-(','sad.gif',35)",
      "insert into VGB_EMOTICON values(null,':-/','angry.gif',40)",
      "insert into VGB_EMOTICON values(null,':-*','sick.gif',45)",
      "insert into VGB_EMOTICON values(null,'8-)','cool.gif',50)",
      "insert into VGB_EMOTICON values(null,':-0','ohmy.gif',55)",
      "insert into VGB_EMOTICON values(null,'8-0','love.gif',60)",
      "insert into VGB_EMOTICON values(null,':-|','unsure.gif',65)",
      "insert into VGB_EMOTICON values(null,':-!','important.gif',70)",
      "insert into VGB_EMOTICON values(null,':-?','question.gif',75)",
      "insert into VGB_EMOTICON values(null,'#-)','crazy.gif',80)",
      "insert into VGB_EMOTICON values(null,':-U','special1.gif',85)",
      "insert into VGB_EMOTICON values(null,':-B','special2.gif',90)",
      "insert into VGB_EMOTICON values(null,':-}','tongue.gif',95)"
    );
    foreach ($queries as $q) {
      vgb_query($q);
    }
    // save the selected countries into database
    addC("0","empty");
    if (file_exists("$GB_DIR/libs/countries.php")) {
      include("$GB_DIR/libs/countries.php");
      if ($preEUROPE)
        vgb_install_Europe();
      if ($preNORTH) 
        vgb_install_NAmerica();
      if ($preSOUTH)
        vgb_install_SAmerica(); 
      if ($preASIA || $preEUROPE) 
        vgb_install_Eurasia();
      if ($preASIA) 
        vgb_install_Asia();
      if ($preAFRICA)
        vgb_install_Africa();
      if ($preOCEANIA)
        vgb_install_Oceania();
      if ($preDEPENDENCY)
        vgb_install_Dependencies();
    }

    // save default values into database
	$BACKURL = str_replace('http://', '', $CONFIG['ecards_more_pic_target']);
	$INDEXURL = str_replace('http://', '', $CONFIG['ecards_more_pic_target']).$GB_FILE;
    $_today = getdate(time());
    $_onlineDate = $_today['year']."-".$_today['mon']."-".
                     $_today['mday'];
    $q = "insert into VGB_SETTINGS values('X1.0','$_onlineDate',".
         "'".addSlashes(vgb_crypt(strtoupper($preADMINPASS),$prePASSWORD))."',";
    $q .= ($preEMAIL == "") ? "null" : "'".AddSlashes($preEMAIL)."'";
    $q .= ",'2000-1-1','".AddSlashes($_skin)."',0,0,0,1,0,5,0,10,10000,".
          MAXLEN_NAME.",".MAXLEN_EMAIL.",".MAXLEN_HOMEPAGE.",".MAXLEN_AIM.
          ",".MAXLEN_MSN.",".MAXLEN_YAHOO.",28,1,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,'-BADWORD-',
          0,10,200,10,200,0,'".$_onlineDate."','$INDEXURL',
          'YW5nWydlcnJvck9jY3VyZWQnXS4iPGJyIC8+PGJyIC8+Ii4kbGFuZ1snbm9Db3B5J10pOw==|ZWNobyI8IS0tIC0tPjxiPlZpUEVSIEd1ZXN0Ym9vayBWIi4kc2V0dGluZ3NbJ1ZFUlNJT04nXS4iPC9iPiAt','2x8PTE7|b3V0KCI8IS0tIC0tPjxhIGhyZWY9J2h0dHA6Ly93d3cudmlwZXJnYi5kZS52dScgdGFyZ2V0PSdfYmxhbmsnICRpblRhZz53d3cudmlwZXJnYi5kZS52dTwvYT4iKTskY2x8PTI7',0, 0,0,1,3,'black=#000000\ngray=#808080\nred=#FF0000\nlime=#00FF00\nyellow=#FFFF00\nblue=#0000FF\nfuchsia=#FF00FF\naqua=#00FFFF\nwhite=#FFFFFF\nmaroon=#800000\ngreen=#008000\nolive=#808000\nnavy=#000080\npurple=#800080\nteal=#008080\nsilver=#C0C0C0','',0,0,0,".        "0,0,0,0,0,0,null,0,1,0,0,null,0,0,0,0,'','',0,0,'".$BACKURL."',0,0,'',0,3,'::user::(a+)::domain::.::tld::','',0,0,0,0,'pass=',100,0,'".$preENCODING."',1,0,1,0,'webmaster@".vgb_servername()."','iso-8859-1','-fwebmaster@".vgb_servername()."',0,'localhost',25,'','',0,0,0,0,".MAXLEN_SKYPE.",".MAXLEN_JABBER.",0,0,0,0,0,'Default',1,0,0,0,'border: 1px dotted #808080; padding: 3px','border: 1px inset ; margin: 0px; padding: 3px; height: 100px; overflow: auto',0,10,0,0,0,0,0)";
    vgb_query($q);
    write_gb_file();

  }
?>
  </body>
</html>
